/*
	Describe a box with things connects at the bottom and the top
	and one thing on the left and one on the right
*/
#include "graph.h"

void _F_grbox::tlink1(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,x,node.y+node.width,2);
}
void _F_grbox::tlink2(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,x,node.y+node.width,2);
}
void _F_grbox::tlink3(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,x,node.y+node.width,2);
}
void _F_grbox::tlink4(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,x,node.y+node.width,2);
}
void _F_grbox::tlink5(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,x,node.y+node.width,2);
}
void _F_grbox::tlink6(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,x,node.y+node.width,2);
}

void _F_grbox::blink1(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,x,node.y,2);
}
void _F_grbox::blink2(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,x,node.y,2);
}
void _F_grbox::blink3(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,x,node.y,2);
}
void _F_grbox::blink4(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,x,node.y,2);
}
void _F_grbox::blink5(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,x,node.y,2);
}
void _F_grbox::blink6(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,x,node.y,2);
}


void _F_grbox::llink(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,node.x+node.depth,node.y+node.width/2,2);
}

void _F_grbox::rlink(int x, int y, GRAPH_MODE mode, GR_NODE &node)
{
	drawline (x,y,node.x,node.y+node.width/2,2);
}




void _F_grbox::titem1(GRAPH_MODE, GR_NODE &)
{
}
void _F_grbox::titem2(GRAPH_MODE, GR_NODE &)
{
}
void _F_grbox::titem3(GRAPH_MODE, GR_NODE &)
{
}
void _F_grbox::titem4(GRAPH_MODE, GR_NODE &)
{
}
void _F_grbox::titem5(GRAPH_MODE, GR_NODE &)
{
}
void _F_grbox::titem6(GRAPH_MODE, GR_NODE &)
{
}

void _F_grbox::bitem1(GRAPH_MODE, GR_NODE &)
{
}
void _F_grbox::bitem2(GRAPH_MODE, GR_NODE &)
{
}
void _F_grbox::bitem3(GRAPH_MODE, GR_NODE &)
{
}
void _F_grbox::bitem4(GRAPH_MODE, GR_NODE &)
{
}
void _F_grbox::bitem5(GRAPH_MODE, GR_NODE &)
{
}
void _F_grbox::bitem6(GRAPH_MODE, GR_NODE &)
{
}

void _F_grbox::litem(GRAPH_MODE, GR_NODE &)
{
}
void _F_grbox::ritem(GRAPH_MODE, GR_NODE &)
{
}
void _F_grbox::box(GRAPH_MODE, GR_NODE &)
{
}



/*
	Draw something and then a thick horizontal line under it
	and then many other things linked to the thick line vertically
*/
void grbox (_F_grbox &c, GRAPH_MODE mode, GR_NODE &node)
{
	node.width = node.height = node.depth = 0;
	node.margin.top = node.margin.right = node.margin.left = 0;
	node.margin.bottom = 0;
	GR_NODE tnode[6];		// Objects on top
	GR_NODE bnode[6];		// Objects on bottom
	GR_NODE lnode;			// Object on left
	GR_NODE rnode;			// Object on right
	GR_NODE boxnode;		// Box in the middle
	//tnode.y = node.y;
	c.litem (GR_EVAL,lnode);
	c.ritem (GR_EVAL,rnode);
	int top_width=0,bot_width=0;
	int top_depth=0,bot_depth=0,right_depth=0,left_depth=0;
	int depth = 0;
	for (int i=0; i<2; i++){
		GRAPH_MODE emode = i==0 ? GR_EVAL : GR_DRAW;
		lnode.x = node.x+5;
		lnode.y = node.y + 5 + top_width + 20;
		if (lnode.width < boxnode.width){
			lnode.y += boxnode.width/2 - lnode.width/2;
		}
		c.litem (emode,lnode);
		if (lnode.depth != 0) left_depth = lnode.depth + 5 + 15;
		boxnode.x = node.x + left_depth;
		boxnode.y = node.y + 5 + top_width + 20;
		c.box (emode,boxnode);
		int top_x = node.x + left_depth + depth/2 - top_depth/2;
		int top_y = boxnode.y - 20;
		int bot_x = node.x + left_depth + depth/2 - bot_depth/2;
		int bot_y = boxnode.y + boxnode.width + 20;
		top_width = 0;
		bot_width = 0;
		top_depth = 0;
		bot_depth = 0;
		// Node on top and bottom
		for (int j=0; j<6; j++){
			GR_NODE *tn = tnode + j;
			GR_NODE *bn = bnode + j;
			tn->x = top_x;
			tn->y = top_y - tn->width;
			bn->x = bot_x;
			bn->y = bot_y;
			switch (j){
			case 0:
				c.titem1(emode,*tn);
				c.bitem1(emode,*bn);
				break;
			case 1:
				c.titem2(emode,*tn);
				c.bitem2(emode,*bn);
				break;
			case 2:
				c.titem3(emode,*tn);
				c.bitem3(emode,*bn);
				break;
			case 3:
				c.titem4(emode,*tn);
				c.bitem4(emode,*bn);
				break;
			case 4:
				c.titem5(emode,*tn);
				c.bitem5(emode,*bn);
				break;
			case 5:
				c.titem6(emode,*tn);
				c.bitem6(emode,*bn);
				break;
			}
			if (tn->width != 0){
				top_depth += tn->depth + 10;
				top_x += tn->depth + 10;
				if (tn->width > top_width) top_width = tn->width;
			}
			if (bn->width != 0){
				bot_depth += bn->depth + 10;
				bot_x += bn->depth + 10;
				if (bn->width > bot_width) bot_width = bn->width;
			}
		}

		depth = boxnode.depth;
		if (top_depth > depth) depth = top_depth;
		if (bot_depth > depth) depth = bot_depth;
		rnode.x = node.x + left_depth + depth + 15;
		//if (rnode.width < boxnode.width){
			rnode.y = top_width + 5 + 20 + boxnode.width/2 - rnode.width/2;
		//}else{
		//	rnode.y = top_width + 5 + 20;
		//}
		c.ritem (emode,rnode);
		if (rnode.depth != 0) right_depth = rnode.depth + 15 + 5;
		node.depth = left_depth + depth + right_depth;

		int core_width = boxnode.width;
		if (lnode.width > core_width) core_width = lnode.width;
		if (rnode.width > core_width) core_width = rnode.width;
		node.width = core_width + top_width + bot_width + 20 + 5 + 20 + 5;
		if (mode == GR_EVAL){
			break;
		}else if (emode == GR_DRAW){
			c.box (emode,boxnode);
			int top_x = node.x + left_depth + depth/2 - top_depth/2;
			int top_y = boxnode.y;
			int bot_x = node.x + left_depth + depth/2 - bot_depth/2;
			int bot_y = boxnode.y + boxnode.width;
			{
				int cy = boxnode.y+boxnode.width/2;
				if (lnode.width != 0) c.llink (boxnode.x,cy,mode,lnode);
				if (rnode.width != 0) c.rlink (boxnode.x+boxnode.depth,cy,mode,rnode);
			}
			for (int j=0; j<6; j++){
				GR_NODE *tn = tnode + j;
				GR_NODE *bn = bnode + j;
				int txc = top_x + tn->depth/2;
				int bxc = bot_x + bn->depth/2;
				switch (j){
				case 0:
					if (tn->width > 0) c.tlink1 (txc,top_y,mode,*tn);
					if (bn->width > 0) c.blink1 (bxc,bot_y,mode,*bn);
					break;
				case 1:
					if (tn->width > 0) c.tlink2 (txc,top_y,mode,*tn);
					if (bn->width > 0) c.blink2 (bxc,bot_y,mode,*bn);
					break;
				case 2:
					if (tn->width > 0) c.tlink3 (txc,top_y,mode,*tn);
					if (bn->width > 0) c.blink3 (bxc,bot_y,mode,*bn);
					break;
				case 3:
					if (tn->width > 0) c.tlink4 (txc,top_y,mode,*tn);
					if (bn->width > 0) c.blink4 (bxc,bot_y,mode,*bn);
					break;
				case 4:
					if (tn->width > 0) c.tlink5 (txc,top_y,mode,*tn);
					if (bn->width > 0) c.blink5 (bxc,bot_y,mode,*bn);
					break;
				case 5:
					if (tn->width > 0) c.tlink6 (txc,top_y,mode,*tn);
					if (bn->width > 0) c.blink6 (bxc,bot_y,mode,*bn);
					break;
				}
				top_x += tn->depth+10;
				bot_x += bn->depth+10;
			}
		}
	}
}


