TLMPWORK_VERSION=0
TLMPWORK_RELEASE=9
TLMP_LIB=$(RPM_BUILD_ROOT)/usr/lib/tlmp
USR_BIN=$(RPM_BUILD_ROOT)/usr/bin
USR_LIB=$(RPM_BUILD_ROOT)/usr/lib
USR_INCLUDE=$(RPM_BUILD_ROOT)/usr/include/tlmp
TLMP_DESK=$(RPM_BUILD_ROOT)/usr/share/applnk/tlmp
INCLUDEDIRECTIVES=-I../framework -I../fileselect `gnome-config --cflags xml`
CCDEFINES=-DTLMPWORK_VERSION=$(TLMPWORK_VERSION) \
		-DTLMPWORK_RELEASE=$(TLMPWORK_RELEASE)
LDEVEL=/usr/lib/linuxconf-devel

FLAGS=-funsigned-char -g -O2 -Wall 

include /usr/lib/linuxconf-devel/ccrules.mak

msg:
	$(LDEVEL)/msgscan $(CURDIR) \
		$(CURDIR).dic $(CURDIR).m EF *.cc *.tlcc

msg.clean: clean
	$(LDEVEL)/msgclean $(CURDIR).dic
	$(LDEVEL)/msgscan $(CURDIR) \
		$(CURDIR).dic $(CURDIR).m EF *.cc *.tlcc

msg.eng:
	mkdir -p $(TLMP_LIB)/help.eng
	$(LDEVEL)/msgcomp -p./ \
		-p$(TLMP_LIB)/messages/sources/ \
		$(TLMP_LIB)/help.eng/tlmpwork.eng eE \
		../tlmpmail/tlmpmail ../framework/framework ../tledit/tledit \
		../agenda/agenda ../graph/graph ../photo/photo ../todo/todo \
		../fileselect/fileselect

msg.fr:
	mkdir -p $(TLMP_LIB)/help.fr
	$(LDEVEL)/msgcomp -p./ \
		-p$(TLMP_LIB)/messages/sources/ \
		$(TLMP_LIB)/help.fr/tlmpwork.fr TFeE \
		../tlmpmail/tlmpmail ../framework/framework ../tledit/tledit \
		../agenda/agenda ../graph/graph ../photo/photo ../todo/todo \
		../fileselect/fileselect

ifdef DIRS
install: $(LOCAL_INSTALL) install_subdirs $(LOCAL_POSTINSTALL)

install_subdirs:
	@echo doing subdirs
	@for i in $(DIRS); do make -C $$i install  || exit 1 ; done
	@echo end subdirs

else
install: $(LOCAL_INSTALL) $(LOCAL_POSTINSTALL)
endif

pubspec_xml:
	@mkdir -p /tmp/xml
	nacom -s$(CURDIR) -x *cc >/tmp/xml/$(CURDIR).xml

