#!/bin/sh
if [ $# = 0 ] ; then
	echo table.sh domain
	echo Create the components database
elif [ "$1" = "create" ] ; then
	mysqladmin create components 
	mysql components <<-EOF
		create table packages (
			pkgid int not null auto_increment primary key,
			package varchar(100),
			index (package),
			url varchar(250)
		);
		create table sections (
			sectionid int not null auto_increment primary key,
			section varchar(40) not null,
			index (section),
			summary varchar(250)
		);
		create table components (
			component varchar(40) binary not null,
			version int default 0,
			index(component,version),
			sectionid int,
			packageid int,
			summary varchar(250),
			isobj char default 'N',
			xml text,
			updated timestamp
		);
		create table specs (
			section varchar(40) not null,
			keyclass varchar(100) not null,
			primary key (section,keyclass),
			txt text,
			updated timestamp
		);
	EOF
elif [ "$1" = "delete" ] ; then
	mysqladmin drop components 
fi


