// PovRay definitions to generate pretty source code screen shot
// using the src_screenshot utility
#include "colors.inc"
#include "stones.inc"
#include "textures.inc"
#include "shapes.inc"
#include "glass.inc"
#include "metals.inc"
#include "woods.inc"

#macro TLMPCALL(title,len,offx,offy)
	box {
		<offx, offy-0.8,  0>,
		<offx+len/2, offy+0.8,   0.5>
		texture {
			pigment { color rgbf<1.0, 1.0, 1.0, 0.7> }
		}
	}
	text { ttf "timrom.ttf" title 1, 0
	    pigment { Red }
		//scale len*x
		translate <offx+0.2,offy-0.5,-2>
	}
#end

#macro TLMPF(title,len,offx,offy)
//	box {
//		<offx, offy,  0>,
//		<offx+len/2, offy+0.8,   0.5>
//		texture {
//			pigment { color rgbf<1.0, 1.0, 1.0, 0.7> }
//		}
//	}
	text { ttf "timrom.ttf" title 1, 0
	    pigment { Red }
		//scale len*x
		translate <offx,offy,1>
	}
#end

#macro TLMPFUNCTION(title,len,offx,offy)
	box {
		<offx, offy-0.8,  0>,
		<offx+len/2, offy+0.8,   0.5>
		texture {
			pigment { color rgbf<1.0, 1.0, 1.0, 0.7> }
		}
	}
	text { ttf "timrom.ttf" title 1, 0
	    pigment { Red }
		//scale len*x
		translate <offx+0.2,offy-0.5,-2>
	}
#end
#macro TLMPOBJ(title,len,offx,offy)
	box {
		<offx, offy-0.8,  0>,
		<offx+len/2, offy+0.8,   0.5>
		texture {
			pigment { color rgbf<1.0, 1.0, 1.0, 0.7> }
		}
	}
	text { ttf "timrom.ttf" title 1, 0
	    pigment { Red }
		//scale len*x
		translate <offx+0.2,offy-0.5,-2>
	}
#end
#declare TUBERADIUS = 0.2;
#macro TLMPTUBE_MIDDLE(len,offx,offy)
	// Horizontal
	cylinder {
		<offx, offy+0.5, 0>,
		<offx+0.5, offy+0.5, 0>
		TUBERADIUS
		texture { pigment {color Yellow }}
	}
	cylinder {
		<offx, offy, 0>,
		<offx, offy+1, 0>,
		TUBERADIUS
		texture { pigment {color Yellow }}
	}
#end

#macro TLMPTUBE(len,offx,offy)
	cylinder {
		<offx, offy, 0>,
		<offx, offy+1, 0>,
		TUBERADIUS
		texture { pigment {color Yellow }}
	}
#end

#macro TLMPTUBE_FIRST(len,offx,offy)
	// Vertical
	cylinder {
		<offx, offy, 0>,
		<offx, offy+1, 0>,
		TUBERADIUS
		texture { pigment {color Yellow }}
	}
	// Horizontal
	cylinder {
		<offx, offy, 0>,
		<offx-1, offy, 0>
		TUBERADIUS
		texture { pigment {color Yellow }}
	}
#end

#macro TLMPTUBE_LAST(len,offx,offy)
	// Horizontal
	cylinder {
		<offx, offy+0.5, 0>,
		<offx+0.5, offy+0.5, 0>
		TUBERADIUS
		texture { pigment {color Yellow }}
	}
	cylinder {
		<offx, offy+1, 0>,
		<offx, offy+0.5, 0>,
		TUBERADIUS
		texture { pigment {color Yellow }}
	}
	sphere {
		<offx,offy+0.5,0> TUBERADIUS
		texture { pigment {color Yellow }}
	}
#end

#macro TLMPTUBE_ONE(len,offx,offy)
	// Horizontal pointing to the functag
	cylinder {
		<offx, offy+0.5, 0>,
		<offx+0.5, offy+0.5, 0>
		TUBERADIUS
		texture { pigment {color Yellow }}
	}
	cylinder {
		<offx, offy+1, 0>,
		<offx, offy+0.5, 0>,
		TUBERADIUS
		texture { pigment {color Yellow }}
	}
	sphere {
		<offx,offy+0.5,0> TUBERADIUS
		texture { pigment {color Yellow }}
	}
#end

background { color White }

light_source { <0,0,-100> White }
