#!/bin/sh
if [ $# = 0 ] ; then
	echo table.sh create [ mysql options ]
	echo table.sh delete [ mysql options ]
	echo table.sh reset [ mysql options ]
	echo Create the mailsql database
elif [ "$1" = "create" ] ; then
	shift
	mysqladmin create usermail $*
	mysql usermail $* <<-EOF
		create table folders (
			id int not null auto_increment primary key,
			foldername varchar(100) not null,
			index (foldername),
			revision int default 0
			);
		create table messages (
			id int not null auto_increment primary key,
			folderid int not null,
			index (folderid),
			subject varchar(250),
			msgid varchar(100),
			index (msgid),
			replyid varchar(100),
			datesent datetime,
			daterec datetime,
			index (daterec),
			modified timestamp,
			index (modified),
			deleted char default 'N',
			viewed char default 'N',
			replied char default 'N',
			tagged char default 'N',
			comment blob,
			size int default 0
		);
		create table addrs (
			id int,
			type char,
			index (id,type),
			addr varchar(100),
			name varchar(100)
		);
		create table parts (
			id int,
			index (id),
			header blob,
			message longblob
		);
	EOF
elif [ "$1" = "delete" ] ; then
	shift
	mysqladmin drop usermail $*
elif [ "$1" = "reset" ] ; then
	shift
	mysql usermail $* <<-EOF
		delete from folders;
		delete from messages;
		delete from addrs;
		delete from parts;
	EOF
elif [ "$1" = "test" ] ; then
	shift
	mysql usermail $* <<-EOF
		insert into folders (foldername) values ('inbox');
	EOF
fi

